TelepathyQt4: OptionalInterfaceFactory< DBusProxySubclass > Class Template Reference

| Home · All Classes · All Namespaces · Modules · Functions · Files

# OptionalInterfaceFactory< DBusProxySubclass > Class Template Reference
[Client-side proxies]

`#include <>>`

Inherits Tp::OptionalInterfaceCache.

List of all members.

## Public Types

- enum InterfaceSupportedChecking { CheckInterfaceSupported, BypassInterfaceCheck }

## Public Member Functions

- OptionalInterfaceFactory (DBusProxySubclass *this_)
- ~OptionalInterfaceFactory ()
- QStringList interfaces () const
- template<class Interface > Interface * optionalInterface (InterfaceSupportedChecking check=CheckInterfaceSupported) const
- template<typename Interface > Interface * interface () const

## Protected Member Functions

- void setInterfaces (const QStringList &interfaces)

## Detailed Description

### template<typename DBusProxySubclass>
class Tp::OptionalInterfaceFactory< DBusProxySubclass >

<TelepathyQt4/OptionalInterfaceFactory>

Implementation helper class for high-level proxy classes willing to offer access to shared instances of interface proxies for optional interfaces.

This class is included in the public API for the benefit of high-level proxies in extensions.

To use this helper in a subclass of DBusProxy (say, ExampleObject), ExampleObject should inherit privately from OptionalInterfaceFactory<ExampleObject>, and call OptionalInterfaceFactory(this) in its constructor's initialization list.

Template Parameters:

  | DBusProxySubclass | A subclass of DBusProxy

## Member Enumeration Documentation

enum InterfaceSupportedChecking

Specifies if the interface being supported by the remote object should be checked by optionalInterface() and the convenience functions for it.

See also:
  optionalInterface()

Enumerator:

  CheckInterfaceSupported | Don't return an interface instance unless it can be guaranteed that the remote object actually implements the interface.
  BypassInterfaceCheck | Return an interface instance even if it can't be verified that the remote object supports the interface.

## Constructor & Destructor Documentation

OptionalInterfaceFactory | ( | DBusProxySubclass * | this_ | ) | `[inline]`

Class constructor.

Parameters:

  | this_ | The class to which this OptionalInterfaceFactory is attached

~OptionalInterfaceFactory | ( |  | ) | `[inline]`

Class destructor.

Frees all interface instances constructed by this factory.

## Member Function Documentation

interfaces | ( |  | ) | const`[inline]`

Return a list of interfaces supported by this object.

Returns:
  List of supported interfaces.

Interface* optionalInterface | ( | InterfaceSupportedChecking | check = `CheckInterfaceSupported` | ) | const`[inline]`

template< typename Interface > inline Interface * interface | ( |  | ) | const`[inline]`

Return a pointer to a valid instance of a interface class, associated with the same remote object as the given main interface instance. The given main interface must be of the class the optional interface is generated for (for eg. ChannelInterfaceGroupInterface this means ChannelInterface) or a subclass.

First invocation of this method for a particular optional interface class will construct the instance; subsequent calls will return a pointer to the same instance.

The returned instance is freed when the factory is destroyed; using it after destroying the factory will likely produce a crash. As the instance is shared, it should not be freed directly.

Template Parameters:

  | Interface | Class of the interface instance to get.

Returns:
  A pointer to an optional interface instance.

void setInterfaces | ( | const QStringList & | interfaces | ) | `[inline, protected]`